Main Page | Namespace List | Class Hierarchy | Alphabetical List | Compound List | File List | Namespace Members | Compound Members | File Members

# BufferedTransformation Class Reference

`#include <cryptlib.h>`

Inheritance diagram for BufferedTransformation:

List of all members.

## Detailed Description

interface for buffered transformations

BufferedTransformation is a generalization of BlockTransformation, StreamTransformation, and HashTransformation.

A buffered transformation is an object that takes a stream of bytes as input (this may be done in stages), does some computation on them, and then places the result into an internal buffer for later retrieval. Any partial result already in the output buffer is not modified by further input.

If a method takes a "blocking" parameter, and you pass "false" for it, the method will return before all input has been processed if the input cannot be processed without waiting (for network buffers to become available, for example). In this case the method will return true or a non-zero integer value. When this happens you must continue to call the method with the same parameters until it returns false or zero, before calling any other method on it or attached BufferedTransformation. The integer return value in this case is approximately the number of bytes left to be processed, and can be used to implement a progress bar.

For functions that take a "propagation" parameter, propagation != 0 means pass on the signal to attached BufferedTransformation objects, with propagation decremented at each step until it reaches 0. -1 means unlimited propagation.

Definition at line 691 of file cryptlib.h.

## INPUT
unsigned int | Put (byte inByte, bool blocking=true)
| input a byte for processing
unsigned int | Put (const byte *inString, unsigned int length, bool blocking=true)
| input multiple bytes
unsigned int | PutWord16 (word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| input a 16-bit word
unsigned int | PutWord32 (word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| input a 32-bit word
virtual byte * | CreatePutSpace (unsigned int &size)
| request space to write bytes into for processing
virtual bool | CanModifyInput () const
unsigned int | PutModifiable (byte *inString, unsigned int length, bool blocking=true)
| input multiple bytes that may be modified by callee
bool | MessageEnd (int propagation=-1, bool blocking=true)
unsigned int | PutMessageEnd (const byte *inString, unsigned int length, int propagation=-1, bool blocking=true)
virtual unsigned int | Put2 (const byte *inString, unsigned int length, int messageEnd, bool blocking)=0
| input multiple bytes for blocking or non-blocking processing
virtual unsigned int | PutModifiable2 (byte *inString, unsigned int length, int messageEnd, bool blocking)
| input multiple bytes that may be modified by callee for blocking or non-blocking processing
## WAITING
unsigned int | GetMaxWaitObjectCount () const
| maximum number of wait objects that this object can return
void | GetWaitObjects (WaitObjectContainer &container)
| put wait objects into container
## SIGNALS
virtual void | IsolatedInitialize (const NameValuePairs &parameters)
virtual bool | IsolatedFlush (bool hardFlush, bool blocking)=0
virtual bool | IsolatedMessageSeriesEnd (bool blocking)
virtual void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| initialize or reinitialize this object
virtual bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| flush buffered input and/or output
virtual bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| mark end of a series of messages
virtual void | SetAutoSignalPropagation (int propagation)
| set propagation of automatically generated and transfered signals
virtual int | GetAutoSignalPropagation () const
## RETRIEVAL OF ONE MESSAGE
virtual unsigned long | MaxRetrievable () const
| returns number of bytes that is currently ready for retrieval
virtual bool | AnyRetrievable () const
| returns whether any bytes are currently ready for retrieval
virtual unsigned int | Get (byte &outByte)
| try to retrieve a single byte
virtual unsigned int | Get (byte *outString, unsigned int getMax)
| try to retrieve multiple bytes
virtual unsigned int | Peek (byte &outByte) const
| peek at the next byte without removing it from the output buffer
virtual unsigned int | Peek (byte *outString, unsigned int peekMax) const
| peek at multiple bytes without removing them from the output buffer
unsigned int | GetWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| try to retrieve a 16-bit word
unsigned int | GetWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| try to retrieve a 32-bit word
unsigned int | PeekWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| try to peek at a 16-bit word
unsigned int | PeekWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| try to peek at a 32-bit word
unsigned long | TransferTo (BufferedTransformation &target, unsigned long transferMax=ULONG_MAX, const std::string &channel=NULL_CHANNEL)
| move transferMax bytes of the buffered output to target as input
virtual unsigned long | Skip (unsigned long skipMax=ULONG_MAX)
| discard skipMax bytes from the output buffer
unsigned long | CopyTo (BufferedTransformation &target, unsigned long copyMax=ULONG_MAX, const std::string &channel=NULL_CHANNEL) const
| copy copyMax bytes of the buffered output to target as input
unsigned long | CopyRangeTo (BufferedTransformation &target, unsigned long position, unsigned long copyMax=ULONG_MAX, const std::string &channel=NULL_CHANNEL) const
| copy copyMax bytes of the buffered output, starting at position (relative to current position), to target as input
## RETRIEVAL OF MULTIPLE MESSAGES
virtual unsigned long | TotalBytesRetrievable () const
virtual unsigned int | NumberOfMessages () const
| number of times MessageEnd() has been received minus messages retrieved or skipped
virtual bool | AnyMessages () const
| returns true if NumberOfMessages() > 0
virtual bool | GetNextMessage ()
| start retrieving the next message
virtual unsigned int | SkipMessages (unsigned int count=UINT_MAX)
| skip count number of messages
unsigned int | TransferMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=NULL_CHANNEL)
unsigned int | CopyMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=NULL_CHANNEL) const
virtual void | SkipAll ()
void | TransferAllTo (BufferedTransformation &target, const std::string &channel=NULL_CHANNEL)
void | CopyAllTo (BufferedTransformation &target, const std::string &channel=NULL_CHANNEL) const
virtual bool | GetNextMessageSeries ()
virtual unsigned int | NumberOfMessagesInThisSeries () const
virtual unsigned int | NumberOfMessageSeries () const
## NON-BLOCKING TRANSFER OF OUTPUT
virtual unsigned int | TransferTo2 (BufferedTransformation &target, unsigned long &byteCount, const std::string &channel=NULL_CHANNEL, bool blocking=true)=0
virtual unsigned int | CopyRangeTo2 (BufferedTransformation &target, unsigned long &begin, unsigned long end=ULONG_MAX, const std::string &channel=NULL_CHANNEL, bool blocking=true) const=0
unsigned int | TransferMessagesTo2 (BufferedTransformation &target, unsigned int &messageCount, const std::string &channel=NULL_CHANNEL, bool blocking=true)
unsigned int | TransferAllTo2 (BufferedTransformation &target, const std::string &channel=NULL_CHANNEL, bool blocking=true)
## CHANNELS
unsigned int | ChannelPut (const std::string &channel, byte inByte, bool blocking=true)
unsigned int | ChannelPut (const std::string &channel, const byte *inString, unsigned int length, bool blocking=true)
unsigned int | ChannelPutModifiable (const std::string &channel, byte *inString, unsigned int length, bool blocking=true)
unsigned int | ChannelPutWord16 (const std::string &channel, word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
unsigned int | ChannelPutWord32 (const std::string &channel, word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
bool | ChannelMessageEnd (const std::string &channel, int propagation=-1, bool blocking=true)
unsigned int | ChannelPutMessageEnd (const std::string &channel, const byte *inString, unsigned int length, int propagation=-1, bool blocking=true)
virtual byte * | ChannelCreatePutSpace (const std::string &channel, unsigned int &size)
virtual unsigned int | ChannelPut2 (const std::string &channel, const byte *begin, unsigned int length, int messageEnd, bool blocking)
virtual unsigned int | ChannelPutModifiable2 (const std::string &channel, byte *begin, unsigned int length, int messageEnd, bool blocking)
virtual void | ChannelInitialize (const std::string &channel, const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
virtual bool | ChannelFlush (const std::string &channel, bool hardFlush, int propagation=-1, bool blocking=true)
virtual bool | ChannelMessageSeriesEnd (const std::string &channel, int propagation=-1, bool blocking=true)
virtual void | SetRetrievalChannel (const std::string &channel)
## ATTACHMENT
virtual bool | Attachable ()
| returns whether this object allows attachment
virtual BufferedTransformation * | AttachedTransformation ()
| returns the object immediately attached to this object or NULL for no attachment
virtual const BufferedTransformation * | AttachedTransformation () const
virtual void | Detach (BufferedTransformation *newAttachment=0)
| delete the current attachment chain and replace it with newAttachment
virtual void | Attach (BufferedTransformation *newAttachment)
| add newAttachment to the end of attachment chain
## Public Member Functions
BufferedTransformation & | Ref ()
| return a reference to this object
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
bool | Wait (unsigned long milliseconds)
| wait on this object
## Static Public Attributes
const std::string | NULL_CHANNEL
## Static Protected Member Functions
int | DecrementPropagation (int propagation)

## Member Function Documentation

BufferedTransformation& BufferedTransformation::Ref | ( |  | ) | `[inline]`

| return a reference to this object This function is useful for passing a temporary BufferedTransformation object to a function that takes a non-const reference. Definition at line 702 of file cryptlib.h.

virtual byte* BufferedTransformation::CreatePutSpace | ( | unsigned int & | size | ) | `[inline, virtual]`

  | request space to write bytes into for processing Parameters:
  size | is requested size (as a hint) for input, and size of the returned space for output
Reimplemented in HashFilter, ArraySink, ArrayXorSink, and ByteQueue. Definition at line 720 of file cryptlib.h. Referenced by ArrayXorSink::CreatePutSpace().

virtual unsigned int BufferedTransformation::Put2 | ( | const byte * | inString,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[pure virtual]`

  | input multiple bytes for blocking or non-blocking processing Parameters:
  messageEnd | means how many filters to signal MessageEnd to, including this one
Implemented in FileSink, MeterFilter, FilterWithBufferedInput, FilterWithInputQueue, HashFilter, SignerFilter, Redirector, StringSinkTemplate< T >, ArraySink, ArrayXorSink, SecretSharing, InformationDispersal, MessageQueue, NetworkSink, ByteQueue, RandomPool, Deflator, and Inflator. Referenced by Redirector::Put2().

virtual unsigned int BufferedTransformation::PutModifiable2 | ( | byte * | inString,
|  | unsigned int | length,
|  | int | messageEnd,
|  | bool | blocking
| ) | `[inline, virtual]`

  | input multiple bytes that may be modified by callee for blocking or non-blocking processing Parameters:
  messageEnd | means how many filters to signal MessageEnd to, including this one
Reimplemented in FilterWithBufferedInput. Definition at line 738 of file cryptlib.h.

bool BufferedTransformation::Flush | ( | bool | hardFlush,
|  | int | propagation = -1,
|  | bool | blocking = true
| ) | `[virtual]`

  | flush buffered input and/or output Parameters:
  hardFlush | is used to indicate whether all data should be flushed
Note: Hard flushes must be used with care. It means try to process and output everything, even if there may not be enough data to complete the action. For example, hard flushing a HexDecoder would cause an error if you do it after inputing an odd number of hex encoded characters. For some types of filters, for example ZlibDecompressor, hard flushes can only be done at "synchronization points". These synchronization points are positions in the data stream that are created by hard flushes on the corresponding reverse filters, in this example ZlibCompressor. This is useful when zlib compressed data is moved across a network in packets and compression state is preserved across packets, as in the ssh2 protocol. Reimplemented in Filter, Redirector, SecretSharing, and InformationDispersal. Definition at line 169 of file cryptlib.cpp. References AttachedTransformation().

bool BufferedTransformation::MessageSeriesEnd | ( | int | propagation = -1,
|  | bool | blocking = true
| ) | `[virtual]`

| mark end of a series of messages There should be a MessageEnd immediately before MessageSeriesEnd. Reimplemented in Filter, and Redirector. Definition at line 175 of file cryptlib.cpp. References AttachedTransformation().

virtual void BufferedTransformation::SetAutoSignalPropagation | ( | int | propagation | ) | `[inline, virtual]`

| set propagation of automatically generated and transfered signals propagation == 0 means do not automaticly generate signals Reimplemented in SourceTemplate< T >, SourceTemplate< FileStore >, SourceTemplate< RandomNumberStore >, and SourceTemplate< StringStore >. Definition at line 778 of file cryptlib.h.

unsigned long BufferedTransformation::MaxRetrievable | ( |  | ) | const`[virtual]`

| returns number of bytes that is currently ready for retrieval All retrieval functions return the actual number of bytes retrieved, which is the lesser of the request number and MaxRetrievable(). Reimplemented in FileStore, RandomNumberStore, NullStore, MessageQueue, ByteQueue, and RandomPool. Definition at line 229 of file cryptlib.cpp. References AttachedTransformation(), and CopyTo(). Referenced by RandomNumberStore::AnyRetrievable(), and Integer::BERDecode().

bool BufferedTransformation::GetNextMessage | ( |  | ) | `[virtual]`

| start retrieving the next message Returns false if no more messages exist or this message is not completely retrieved. Reimplemented in MessageQueue, and Store. Definition at line 318 of file cryptlib.cpp. References AnyMessages(), and AttachedTransformation().

virtual bool BufferedTransformation::Attachable | ( |  | ) | `[inline, virtual]`

| returns whether this object allows attachment Some BufferedTransformation objects (e.g. Filter objects) allow other BufferedTransformation objects to be attached. When this is done, the first object instead of buffering its output, sents that output to the attached object as input. The entire attachment chain is deleted when the anchor object is destructed. Reimplemented in Filter. Definition at line 926 of file cryptlib.h. Referenced by Attach().

bool Waitable::Wait | ( | unsigned long | milliseconds | ) | `[inherited]`

| wait on this object same as creating an empty container, calling GetWaitObjects(), and calling Wait() on the container Definition at line 101 of file wait.cpp. References Waitable::GetWaitObjects(), and WaitObjectContainer::Wait(). Referenced by NetworkSource::GeneralPump2(), and NetworkSink::TimedFlush().

The documentation for this class was generated from the following files:

- cryptlib.h
- cryptlib.cpp